import * as i1 from '@mintplayer/ng-swiper/observe-size';
import { BsObserveSizeDirective, Size } from '@mintplayer/ng-swiper/observe-size';
import { AnimationBuilder, AnimationPlayer } from '@angular/animations';
import * as i0 from '@angular/core';
import { AfterViewInit, ElementRef, QueryList, EventEmitter } from '@angular/core';
import { Observable, BehaviorSubject } from 'rxjs';
import * as i3 from '@angular/common';

interface Point {
    x: number;
    y: number;
}

interface LastTouch {
    position: Point;
    isTouching: boolean;
}

interface StartTouch {
    position: Point;
    timestamp: number;
}

declare class BsSwipeContainerDirective implements AfterViewInit {
    private animationBuilder;
    private observeSize;
    constructor(element: ElementRef, animationBuilder: AnimationBuilder, document: any, observeSize: BsObserveSizeDirective);
    offsetLeft: number | null;
    offsetRight: number | null;
    offsetTop: number | null;
    offsetBottom: number | null;
    set swipes(value: QueryList<BsSwipeDirective>);
    minimumOffset: number;
    get imageIndex(): number;
    set imageIndex(value: number);
    imageIndexChange: EventEmitter<number>;
    actualSwipes$: Observable<BsSwipeDirective[]>;
    isViewInited$: BehaviorSubject<boolean>;
    startTouch$: BehaviorSubject<StartTouch | null>;
    lastTouch$: BehaviorSubject<LastTouch | null>;
    swipes$: BehaviorSubject<QueryList<BsSwipeDirective> | null>;
    slideSizes$: Observable<(Size | undefined)[]>;
    imageIndex$: BehaviorSubject<number>;
    currentSlideHeight$: Observable<number>;
    pendingAnimation?: AnimationPlayer;
    containerElement: ElementRef<HTMLDivElement>;
    document: Document;
    offset$: Observable<number>;
    offsetLeft$: Observable<number>;
    offsetRight$: Observable<number>;
    padLeft$: Observable<number>;
    padRight$: Observable<number>;
    ngAfterViewInit(): void;
    animateToIndexByDx(dx: number): void;
    animateToIndex(oldIndex: number, newIndex: number, dx: number, totalSlides: number): void;
    onSwipe(dx: number): void;
    previous(): void;
    next(): void;
    goto(index: number): void;
    private gotoAnimate;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSwipeContainerDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BsSwipeContainerDirective, "[bsSwipeContainer]", ["bsSwipeContainer"], { "minimumOffset": { "alias": "minimumOffset"; "required": false; }; "imageIndex": { "alias": "imageIndex"; "required": false; }; }, { "imageIndexChange": "imageIndexChange"; }, ["swipes"], never, false, [{ directive: typeof i1.BsObserveSizeDirective; inputs: {}; outputs: {}; }]>;
}

declare class BsSwipeDirective {
    private container;
    constructor(container: BsSwipeContainerDirective, observeSize: BsObserveSizeDirective);
    observeSize: BsObserveSizeDirective;
    offside: boolean;
    classes: boolean;
    hostClass?: string;
    onTouchStart(ev: TouchEvent): void;
    onTouchMove(ev: TouchEvent): void;
    onTouchEnd(ev: TouchEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSwipeDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BsSwipeDirective, "[bsSwipe]", never, { "offside": { "alias": "offside"; "required": false; }; }, {}, never, never, false, [{ directive: typeof i1.BsObserveSizeDirective; inputs: {}; outputs: {}; }]>;
}

declare class BsSwiperModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSwiperModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<BsSwiperModule, [typeof BsSwipeDirective, typeof BsSwipeContainerDirective], [typeof i3.CommonModule], [typeof BsSwipeDirective, typeof BsSwipeContainerDirective]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<BsSwiperModule>;
}

export { BsSwipeContainerDirective, BsSwipeDirective, BsSwiperModule };
export type { LastTouch, Point, StartTouch };
